(function($) {
    "use strict";
    var animationInterval = 0;
    var animationClass = "ginger-menu-fade";
    var isInMobile = false;
    var tempString = "";
    var displayStatus = false;
    var widgetStatus = false;
    var idleTimer = 0;
    var idleInterval;
    var intervalTime = 50;
    var isButtonClicked = 0;
    var isDesktop = true;
    var customCSS = "";
    var timezone = 0;
    var animationInterval;

    $(document).ready(function(){
        if(/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|ipad|iris|kindle|Android|Silk|lge |maemo|midp|mmp|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i.test(navigator.userAgent)
            || /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(navigator.userAgent.substr(0,4))) {
            isDesktop = false;
            isInMobile = true;
        }

        if(typeof gsb_settings == "object") {
            if(gsb_settings.buttons.length) {
                $.each(gsb_settings.buttons, function (key, button){
                    var activeButtons = getActiveButtons(button);
                    var widgetSize = parseInt(button.settings.icon_size);
                    var buttonPosition = getButtonPosition(button);
                    if(activeButtons > 0) {
                        var buttonHtml = "<div class='gsb-buttons active has-shadow' id='gsb-buttons-"+button.id+"' data-id='"+button.id+"'>" +
                            "<div class='gsb-buttons-content'>" +
                            "<div class='gsb-button-list'></div>" +
                            "<div class='gsb-trigger'></div>" +
                            "</div>" +
                            "</div>";
                        $("body").append(buttonHtml);

                        var closeButtonHtml = "<div class='gsb-trigger-button'>" +
                            "<div class='gsb-trigger-top'>" +
                            "<a role='button' href='#' class='chat-button-link'>" +
                            "<span class='sr-only'>Contact Us</span>" +
                            ""+button.settings.icon_url+"" +
                            "</a> " +
                            "</div>" +
                            "<div class='gsb-trigger-bottom'>" +
                            "<a role='button' href='#' class='chat-button-link'>" +
                            "<span class='sr-only'>Close</span>" +
                            "<span class='chat-button-icon'>" +
                            "<svg xmlns='http://www.w3.org/2000/svg' fill='#ffffff' viewBox='0 0 30 30' width='90' height='90' ><path d='M7 4c-.256 0-.512.097-.707.293l-2 2a1 1 0 0 0 0 1.414L11.586 15l-7.293 7.293a1 1 0 0 0 0 1.414l2 2a1 1 0 0 0 1.414 0L15 18.414l7.293 7.293a1 1 0 0 0 1.414 0l2-2a1 1 0 0 0 0-1.414L18.414 15l7.293-7.293a1 1 0 0 0 0-1.414l-2-2a1 1 0 0 0-1.414 0L15 11.586 7.707 4.293C7.512 4.097 7.256 4 7 4z'/></svg>" +
                            "</span>" +
                            "</a> " +
                            "</div>" +
                            "</div>";
                        $("#gsb-buttons-"+button.id+" .gsb-trigger").html(closeButtonHtml);
                        console.log(activeButtons);
                        if(activeButtons == 1) {
                            var channelSetting = "";
                            $.each(button.channels, function (key, channel) {
                                if (isChannelActive(channel)) {
                                    channelSetting = getChannelSetting(channel, button.id);
                                }
                            });
                            if(channelSetting != "") {
                                console.log($("#gsb-buttons-"+button.id+" .gsb-trigger .gsb-trigger-button").length);
                                $("#gsb-buttons-"+button.id+" .gsb-trigger .gsb-trigger-button").html(channelSetting);
                                $("#gsb-buttons-"+button.id).addClass("single");
                                $("#gsb-buttons-"+button.id+ " .scb-tooltip").addClass("cooltipz--visible");
                                $("#gsb-buttons-"+button.id+ " .scb-tooltip").attr("data-tooltip-dir", (buttonPosition=="right")?"left":"right");
                            }
                        } else {
                            $.each(button.channels, function (key, channel) {
                                if (isChannelActive(channel)) {
                                    var channelSetting = getChannelSetting(channel, button.id);
                                    $("#gsb-buttons-"+button.id+" .gsb-button-list").append(channelSetting);
                                }
                            });
                        }

                        var closeButton = "";
                        if(button.settings.default_state == "open" && button.settings.show_close_button == "no") {
                            closeButton = "has-no-close-button";
                        }
                        $("#gsb-buttons-" + button.id ).addClass(closeButton);
                        if(button.settings.default_state == "open" && button.settings.show_close_button == "yes") {
                            $("#gsb-buttons-" + button.id ).addClass("has-close-button");
                        }

                        var i = 0;
                        if($("#gsb-buttons-" + button.id).hasClass("has-no-close-button")) {
                        }else{
                            for(i=0; i < activeButtons; i++) {
                                if(button.settings.menu_view == "vertical") {
                                    if(button.settings.menu_animation == "ginger-menu-none") {
                                        customCSS += "#gsb-buttons-" + button.id + " .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px); transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1); display: none;}";
                                        customCSS += "#gsb-buttons-" + button.id + ".open-buttons .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px); transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1); display: block;}";
                                    } else if(button.settings.menu_animation == "ginger-menu-slide") {
                                        customCSS += "#gsb-buttons-" + button.id + " .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateY(0px) scale(1); transform: translateY(0px) scale(1); transition-delay: "+((i + 1)*0.075)+"s;}";
                                        customCSS += "#gsb-buttons-" + button.id + ".open-buttons .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px) scale(1); transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1);}";
                                    } else if(button.settings.menu_animation == "ginger-menu-fade"){
                                        customCSS += "#gsb-buttons-" + button.id + " .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px); transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1); opacity: 0; visibility: hidden; transition-delay: "+((activeButtons - i - 1)*0.1)+"s;}";
                                        customCSS += "#gsb-buttons-" + button.id + ".open-buttons .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px); transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1);  opacity: 1; visibility: visible;}";
                                    } else if(button.settings.menu_animation == "ginger-menu-spin"){
                                        customCSS += "#gsb-buttons-" + button.id + " .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px)  rotate(0deg); transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px)  rotate(0deg); transition-delay: "+((activeButtons - i - 1)*0.1)+"s;}";
                                        customCSS += "#gsb-buttons-" + button.id + ".open-buttons .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px) rotate(360deg); transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px) rotate(360deg);}";
                                    } else if(button.settings.menu_animation == "ginger-menu-pop"){
                                        customCSS += "#gsb-buttons-" + button.id + " .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px) scale(0); transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px) scale(0); transition-delay: "+((activeButtons - i - 1)*0.075)+"s;}";
                                        customCSS += "#gsb-buttons-" + button.id + ".open-buttons .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px) scale(1); transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px) scale(1);}";
                                    } else {
                                        customCSS += "#gsb-buttons-" + button.id + " .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px); transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1); display: none;}";
                                        customCSS += "#gsb-buttons-" + button.id + ".open-buttons .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px); transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1); display: block;}";
                                    }
                                } else {
                                    if(buttonPosition == "right") {
                                        if(button.settings.menu_animation == "ginger-menu-none") {
                                            customCSS += "#gsb-buttons-" + button.id + " .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px); transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1); display: none;}";
                                            customCSS += "#gsb-buttons-" + button.id + ".open-buttons .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px); transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1); display: block;}";
                                        } else if(button.settings.menu_animation == "ginger-menu-slide") {
                                            customCSS += "#gsb-buttons-" + button.id + " .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(0px) scale(1); transform: translateX(0px) scale(1); transition-delay: "+((i + 1)*0.075)+"s;}";
                                            customCSS += "#gsb-buttons-" + button.id + ".open-buttons .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px) scale(1); transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1);}";
                                        } else if(button.settings.menu_animation == "ginger-menu-fade"){
                                            customCSS += "#gsb-buttons-" + button.id + " .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px); transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1); opacity: 0; visibility: hidden; transition-delay: "+((activeButtons - i - 1)*0.1)+"s;}";
                                            customCSS += "#gsb-buttons-" + button.id + ".open-buttons .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px); transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1);  opacity: 1; visibility: visible;}";
                                        } else if(button.settings.menu_animation == "ginger-menu-spin"){
                                            customCSS += "#gsb-buttons-" + button.id + " .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px)  rotate(0deg); transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px)  rotate(0deg); transition-delay: "+((activeButtons - i - 1)*0.1)+"s;}";
                                            customCSS += "#gsb-buttons-" + button.id + ".open-buttons .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px) rotate(360deg); transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px) rotate(360deg);}";
                                        } else if(button.settings.menu_animation == "ginger-menu-pop"){
                                            customCSS += "#gsb-buttons-" + button.id + " .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px) scale(0); transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px) scale(0); transition-delay: "+((activeButtons - i - 1)*0.075)+"s;}";
                                            customCSS += "#gsb-buttons-" + button.id + ".open-buttons .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px) scale(1); transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px) scale(1);}";
                                        } else {
                                            customCSS += "#gsb-buttons-" + button.id + " .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px); transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1); display: none;}";
                                            customCSS += "#gsb-buttons-" + button.id + ".open-buttons .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px); transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1); display: block;}";
                                        }
                                        //customCSS += "#gsb-buttons-" + button.id + ".open-buttons .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px) scale(1) rotate(360deg); transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1) rotate(360deg);}";
                                    } else {
                                        if(button.settings.menu_animation == "ginger-menu-none") {
                                            customCSS += "#gsb-buttons-" + button.id + " .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px); transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1); display: none;}";
                                            customCSS += "#gsb-buttons-" + button.id + ".open-buttons .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px); transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1); display: block;}";
                                        } else if(button.settings.menu_animation == "ginger-menu-slide") {
                                            customCSS += "#gsb-buttons-" + button.id + " .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(0px) scale(1); transform: translateX(0px) scale(1); transition-delay: "+((i + 1)*0.075)+"s;}";
                                            customCSS += "#gsb-buttons-" + button.id + ".open-buttons .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px) scale(1); transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1);}";
                                        } else if(button.settings.menu_animation == "ginger-menu-fade"){
                                            customCSS += "#gsb-buttons-" + button.id + " .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px); transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1); opacity: 0; visibility: hidden; transition-delay: "+((activeButtons - i - 1)*0.1)+"s;}";
                                            customCSS += "#gsb-buttons-" + button.id + ".open-buttons .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px); transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1);  opacity: 1; visibility: visible;}";
                                        } else if(button.settings.menu_animation == "ginger-menu-spin"){
                                            customCSS += "#gsb-buttons-" + button.id + " .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px)  rotate(0deg); transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px)  rotate(0deg); transition-delay: "+((activeButtons - i - 1)*0.1)+"s;}";
                                            customCSS += "#gsb-buttons-" + button.id + ".open-buttons .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px) rotate(360deg); transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px) rotate(360deg);}";
                                        } else if(button.settings.menu_animation == "ginger-menu-pop"){
                                            customCSS += "#gsb-buttons-" + button.id + " .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px) scale(0); transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px) scale(0); transition-delay: "+((activeButtons - i - 1)*0.075)+"s;}";
                                            customCSS += "#gsb-buttons-" + button.id + ".open-buttons .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px) scale(1); transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px) scale(1);}";
                                        } else {
                                            customCSS += "#gsb-buttons-" + button.id + " .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px); transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1); display: none;}";
                                            customCSS += "#gsb-buttons-" + button.id + ".open-buttons .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px); transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1); display: block;}";
                                        }
                                        //customCSS += "#gsb-buttons-" + button.id + ".open-buttons .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px) scale(1) rotate(360deg); transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1) rotate(360deg);}";
                                    }
                                }
                            }
                        }


                        var i = 1;
                        var j = 0;
                        for(i=1,j=0; i < activeButtons,j <activeButtons; i++,j++) {
                            if(button.settings.menu_view == "vertical") {
                                if(buttonPosition == "right") {
                                    customCSS += "#gsb-buttons-" + button.id + ".has-no-close-button:not(.single) .gsb-button-list .chat-button:nth-child(" + (j + 1) + ") {opacity: 1;visibility: visible;pointer-events: auto;right: 0;-webkit-transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px); transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px);transition-delay:-2s;}";
                                } else {
                                    customCSS += "#gsb-buttons-" + button.id + ".has-no-close-button:not(.single) .gsb-button-list .chat-button:nth-child(" + (j + 1) + ") {opacity: 1;visibility: visible;pointer-events: auto;left: 0;-webkit-transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px); transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px);transition-delay:-2s;}";
                                }
                            }else {
                                if(buttonPosition == "right") {
                                    customCSS += "#gsb-buttons-" + button.id + ".has-no-close-button:not(.single) .gsb-button-list .chat-button:nth-child(" + (j + 1) + ") {opacity: 1;visibility: visible;pointer-events: auto;right: 0;-webkit-transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px); transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px);transition-delay:-2s;}";
                                } else {
                                    customCSS += "#gsb-buttons-" + button.id + ".has-no-close-button:not(.single) .gsb-button-list .chat-button:nth-child(" + (j + 1) + ") {opacity: 1;visibility: visible;pointer-events: auto;left: 0;-webkit-transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px); transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px);transition-delay:-2s;}";
                                }
                            }
                        }

                        var i = 0;
                        for(i=0; i < activeButtons; i++) {
                            if(button.settings.menu_view == "vertical") {
                                if(buttonPosition == "right") {
                                    customCSS += "#gsb-buttons-" + button.id + ".open-buttons.has-close-button .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px); transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1); display: block;transition-delay:-2s;}";
                                } else {
                                    customCSS += "#gsb-buttons-" + button.id + ".open-buttons.has-close-button .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px); transform: translateY(-" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1); display: block;transition-delay:-2s;}";
                                }
                            }else {
                                if(buttonPosition == "right") {
                                    customCSS += "#gsb-buttons-" + button.id + ".open-buttons.has-close-button .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px); transform: translateX(-" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1); display: block;transition-delay:-2s;}";
                                } else {
                                    customCSS += "#gsb-buttons-" + button.id + ".open-buttons.has-close-button .gsb-button-list .chat-button:nth-child(" + (i + 1) + ") {-webkit-transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px); transform: translateX(" + ((widgetSize + 8) * (activeButtons - i)) + "px)  scale(1); display: block;transition-delay:-2s;}";
                                }
                            }
                        }

                        var isTriggered = getCookie("gsb-button-click-"+button.id);
                        if(button.settings.default_state == "open") {
                            if(button.settings.hide_menu_after_close_click == "no") {
                                $("#gsb-buttons-"+button.id).addClass("open-buttons");
                                if(isTriggered) {
                                    $("#gsb-buttons-"+button.id).removeClass("has-close-button");
                                }
                            }else {
                                if(!(isTriggered)) {
                                    $("#gsb-buttons-"+button.id).addClass("open-buttons");
                                }
                                else {
                                    $("#gsb-buttons-"+button.id).removeClass("has-close-button");
                                }
                            }
                        }
                    }
                    var buttonPadding = Math.ceil(widgetSize*2/10);
                    customCSS += "#gsb-buttons-" + button.id +" .chat-button {width: "+(widgetSize+8)+"px; height: "+(widgetSize+8)+"px; }";
                    customCSS += "#gsb-buttons-" + button.id +" .gsb-trigger {width: "+(widgetSize+8)+"px; height: "+(widgetSize+8)+"px; }";
                    customCSS += "#gsb-buttons-" + button.id +" .chat-button-link {width: "+(widgetSize)+"px; height: "+(widgetSize)+"px; padding: "+buttonPadding+"px; }";
                    customCSS += "#gsb-buttons-" + button.id +" .gsb-trigger-button {width: "+(widgetSize)+"px; height: "+(widgetSize)+"px; }";
                    customCSS += "#gsb-buttons-" + button.id +" .gsb-trigger .gsb-trigger-top {width: "+(widgetSize)+"px; height: "+(widgetSize)+"px; }";
                    customCSS += "#gsb-buttons-" + button.id +" .gsb-trigger .gsb-trigger-bottom {width: "+(widgetSize)+"px; height: "+(widgetSize)+"px; }";
                    customCSS += "#gsb-buttons-" + button.id +" .chat-button-icon {width: "+(widgetSize - (2*buttonPadding))+"px; height: "+(widgetSize - (2*buttonPadding))+"px; }";

                    /* for main icon */
                    customCSS += "#gsb-buttons-" + button.id +" .gsb-trigger .gsb-trigger-top .chat-button-link {background: "+button.settings.bg_color+"; color: "+button.settings.text_color+";  }";
                    customCSS += "#gsb-buttons-" + button.id +" .gsb-trigger .gsb-trigger-top .chat-button-link svg {fill: "+button.settings.text_color+"; color: "+button.settings.text_color+";  }";
                    customCSS += "#gsb-buttons-" + button.id +" .gsb-trigger .gsb-trigger-bottom .chat-button-link {background: "+button.settings.bg_color+"; color: "+button.settings.text_color+";  }";
                    customCSS += "#gsb-buttons-" + button.id +" .gsb-trigger .gsb-trigger-bottom .chat-button-link svg {fill: "+button.settings.text_color+"; color: "+button.settings.text_color+";  }";

                    customCSS += "#gsb-buttons-" + button.id +" .gsb-trigger .gsb-trigger-top .chat-button-link:hover {background: "+button.settings.interaction_bg_color+"; color: "+button.settings.interaction_text_color+";  }";
                    customCSS += "#gsb-buttons-" + button.id +" .gsb-trigger .gsb-trigger-top .chat-button-link:hover svg {fill: "+button.settings.interaction_text_color+"; color: "+button.settings.interaction_text_color+";  }";
                    customCSS += "#gsb-buttons-" + button.id +" .gsb-trigger .gsb-trigger-bottom .chat-button-link:hover {background: "+button.settings.interaction_bg_color+"; color: "+button.settings.interaction_text_color+";  }";
                    customCSS += "#gsb-buttons-" + button.id +" .gsb-trigger .gsb-trigger-bottom .chat-button-link:hover svg {fill: "+button.settings.interaction_text_color+"; color: "+button.settings.interaction_text_color+";  }";

                    customCSS += "#gsb-buttons-" + button.id +" .chat-button-link {border-radius: "+button.settings.border_radius + "px; }";

                    customCSS += "#gsb-buttons-" + button.id +" [data-scb][data-tooltip-dir]::after, [data-scb][class*=cooltipz]::after {background-color: "+button.settings.tooltip_settings.bg_color+"; color: "+button.settings.tooltip_settings.text_color+"; border-radius: "+button.settings.tooltip_settings.border_radius+"px; font-size:"+button.settings.tooltip_settings.font_size+"px; line-height: "+button.settings.tooltip_settings.tooltip_height+"px; }";
                    customCSS += "#gsb-buttons-" + button.id +" [data-scb][data-tooltip-dir][data-tooltip-dir=left]::before, [data-scb][data-tooltip-dir].cooltipz--left::before, [data-scb][class*=cooltipz][data-tooltip-dir=left]::before, [data-scb][class*=cooltipz].cooltipz--left::before {border-left-color: "+button.settings.tooltip_settings.bg_color+"; }";
                    customCSS += "#gsb-buttons-" + button.id +" [data-scb][data-tooltip-dir][data-tooltip-dir=top]::before, [data-scb][data-tooltip-dir].cooltipz--top::before, [data-scb][class*=cooltipz][data-tooltip-dir=top]::before, [data-scb][class*=cooltipz].cooltipz--top::before {border-top-color: "+button.settings.tooltip_settings.bg_color+"; }"
                    customCSS += "#gsb-buttons-" + button.id +" [data-scb][data-tooltip-dir][data-tooltip-dir=right]::before, [data-scb][data-tooltip-dir].cooltipz--right::before, [data-scb][class*=cooltipz][data-tooltip-dir=right]::before, [data-scb][class*=cooltipz].cooltipz--right::before {border-right-color: "+button.settings.tooltip_settings.bg_color+"; }";

                    if(button.settings.tooltip_settings.border_radius == '0' && button.settings.tooltip_settings.tooltip_height == '0' && button.settings.tooltip_settings.font_size == '0') {
                        customCSS += "#gsb-buttons-" + button.id +" [data-scb][data-tooltip-dir][data-tooltip-dir=left]::before, [data-scb][data-tooltip-dir].cooltipz--left::before, [data-scb][class*=cooltipz][data-tooltip-dir=left]::before, [data-scb][class*=cooltipz].cooltipz--left::before, [data-scb][data-tooltip-dir][data-tooltip-dir=right]::before, [data-scb][data-tooltip-dir].cooltipz--right::before, [data-scb][class*=cooltipz][data-tooltip-dir=right]::before, [data-scb][class*=cooltipz].cooltipz--right::before, [data-scb][data-tooltip-dir][data-tooltip-dir=bottom]::before, [data-scb][data-tooltip-dir].cooltipz--bottom::before, [data-scb][class*=cooltipz][data-tooltip-dir=bottom]::before, [data-scb][class*=cooltipz].cooltipz--bottom::before, [data-scb][data-tooltip-dir][data-tooltip-dir=bottom-left]::before, [data-scb][data-tooltip-dir].cooltipz--bottom-left::before, [data-scb][class*=cooltipz][data-tooltip-dir=bottom-left]::before, [data-scb][class*=cooltipz].cooltipz--bottom-left::before, [data-scb][data-tooltip-dir][data-tooltip-dir=bottom-right]::before, [data-scb][data-tooltip-dir].cooltipz--bottom-right::before, [data-scb][class*=cooltipz][data-tooltip-dir=bottom-right]::before, [data-scb][class*=cooltipz].cooltipz--bottom-right::before, [data-scb][data-tooltip-dir][data-tooltip-dir=top]::before, [data-scb][data-tooltip-dir].cooltipz--top::before, [data-scb][class*=cooltipz][data-tooltip-dir=top]::before, [data-scb][class*=cooltipz].cooltipz--top::before, [data-scb][data-tooltip-dir][data-tooltip-dir=top-left]::before, [data-scb][data-tooltip-dir].cooltipz--top-left::before, [data-scb][class*=cooltipz][data-tooltip-dir=top-left]::before, [data-scb][class*=cooltipz].cooltipz--top-left::before, [data-scb][data-tooltip-dir][data-tooltip-dir=top-right]::before, [data-scb][data-tooltip-dir].cooltipz--top-right::before, [data-scb][class*=cooltipz][data-tooltip-dir=top-right]::before, [data-scb][class*=cooltipz].cooltipz--top-right::before { border : 0 }";
                    }

                    if($("#gsb-buttons-"+button.id).hasClass("single")) {
                        customCSS += "#gsb-buttons-"+button.id+" .gsb-trigger {padding: 0;}";
                    }

                    customCSS += "#gsb-buttons-"+button.id+" .gsb-trigger .chat-button a:not(."+button.settings.animation+") .gsb-pending-message {top: 3%; right: 3%;}";
                    customCSS += "#gsb-buttons-"+button.id+" .gsb-trigger .chat-button a:not(."+button.settings.animation+") + .gsb-pending-message {top: 3%; right: 3%;}";

                    if(button.settings.animation == "none" || button.settings.animation == "ginger-btn-fade" || button.settings.animation == "ginger-btn-pulse" || button.settings.animation == "ginger-btn-spin") {
                        customCSS += "#gsb-buttons-"+button.id+" .gsb-trigger .chat-button a."+button.settings.animation+" .gsb-pending-message {top: 3%; right: 3%;}";
                        customCSS += "#gsb-buttons-"+button.id+" .gsb-trigger .chat-button a."+button.settings.animation+" + .gsb-pending-message {top: 3%; right: 3%;}";
                    }

                    var textPos = getTooltipPosition(button);

                    $("#gsb-buttons-" + button.id +" .gsb-button-list a.scb-tooltip").attr("data-tooltip-dir", textPos);

                    $("#gsb-buttons-" + button.id).addClass(buttonPosition + "-side");
                    $("#gsb-buttons-" + button.id).addClass(button.settings.menu_view + "-menu");

                    if(button.settings.menu_view == "vertical") {
                        if (buttonPosition == "left") {
                            $("#gsb-buttons-" + button.id + " .gsb-trigger-top").attr("data-tooltip-dir", "right");
                            $("#gsb-buttons-" + button.id + " .gsb-trigger-bottom .chat-button-link").attr("data-tooltip-dir", "right");
                        } else {
                            $("#gsb-buttons-" + button.id + " .gsb-trigger-top").attr("data-tooltip-dir", "left");
                            $("#gsb-buttons-" + button.id + " .gsb-trigger-bottom .chat-button-link").attr("data-tooltip-dir", "left");
                        }
                    } else {
                        $("#gsb-buttons-" + button.id + " .gsb-trigger-bottom .chat-button-link").attr("data-tooltip-dir", "top");
                        if (buttonPosition == "left") {
                            $("#gsb-buttons-" + button.id + " .gsb-trigger-top").attr("data-tooltip-dir", "right");
                        } else {
                            $("#gsb-buttons-" + button.id + " .gsb-trigger-top").attr("data-tooltip-dir", "left");
                        }
                    }

                    var ctaButtonText = button.settings.call_to_action;
                    if(ctaButtonText != "") {
                        $("#gsb-buttons-" + button.id + " .gsb-trigger-top").attr("data-scb", ctaButtonText).addClass("cooltipz--visible");
                    }

                    $(document).on("click", "#gsb-buttons-"+button.id+" .gsb-trigger .gsb-trigger-top a", function(){
                        setCookie("gsb-button-click-" + button.id, true , 2);
                    });

                    $(document).on("click", "#gsb-buttons-"+button.id+" .gsb-trigger .gsb-trigger-top a, #gsb-buttons-"+button.id+" .gsb-trigger .chat-button a", function(){
                        setCookie("gsb-button-click-" + button.id, true , 2);
                        //$(".gsb-pending-message").remove();
                    });

                    $(document).on("click", "#gsb-buttons-"+button.id+" .gsb-trigger .gsb-trigger-bottom a", function(){
                        setCookie("gsb-button-click-" + button.id, true , 2);
                        $("#gsb-buttons-"+button.id+" .gsb-pending-message").remove();
                    });

                    $(document).on("mouseenter","#gsb-buttons-"+button.id+" .gsb-trigger a", function(){
                        $("#gsb-buttons-"+button.id+" .gsb-trigger .gsb-trigger-top a").removeClass(button.settings.animation);
                        $("#gsb-buttons-"+button.id+" .gsb-trigger .chat-button a").removeClass(button.settings.animation);
                    });

                    var font_family = button.settings.font_family;
                    if(font_family != "" && font_family != "Arial" && font_family != "Tahoma" && font_family != "Verdana" && font_family != "Helvetica" && font_family != "Times New Roman" && font_family != "Trebuchet MS" && font_family != "Georgia") {
                        $("head").append("<link id='#gsb-buttons-"+button.id+"' href='https://fonts.googleapis.com/css?family="+ button.settings.font_family +"' rel='stylesheet' type='text/css' >");
                    }
                    if(font_family != "") {
                        $("#gsb-buttons-"+button.id).css("font-family", font_family);
                    } else {
                        $("#gsb-buttons-"+button.id).css("font-family", "-apple-system,BlinkMacSystemFont,Segoe UI,Roboto,Oxygen-Sans,Ubuntu,Cantarell,Helvetica Neue,sans-serif");
                    }

                    //Menu animation
                    $("#gsb-buttons-" + button.id +" .gsb-button-list").addClass(button.settings.menu_animation);

                    checkForPendingMessage(button);

                    checkForAnimation(button);

                    checkForOnHoverText(button);

                    checkForTimeDelay(button);

                    checkForPageScroll(button);

                    checkForExitIntent(button);

                    $(document).on("click", "#gsb-buttons-"+button.id+":not(.single) .gsb-trigger .gsb-trigger-top a", function(e){
                        e.preventDefault();
                        $(this).closest(".gsb-buttons").addClass("open-buttons");
                        //animationInterval = setInterval(function () {
                        //    $("#gsb-buttons-"+button.id +" .gsb-button-list .chat-button:not(.active):last").addClass("active");
                        //    if ($("#gsb-buttons-"+button.id +" .gsb-button-list .chat-button:not(.active)").length == 0) {
                        //        window.clearInterval(animationInterval);
                        //    }
                        //}, 100);
                    });

                    $(document).on("click", "#gsb-buttons-"+button.id+":not(.single) .gsb-trigger .gsb-trigger-bottom a", function(e){
                        e.preventDefault();
                        $(this).closest(".gsb-buttons").removeClass("open-buttons");
                        //animationInterval = setInterval(function () {
                        //    $("#gsb-buttons-"+button.id +" .gsb-button-list .chat-button.active:first").removeClass("active");
                        //    if ($("#gsb-buttons-"+button.id +" .gsb-button-list .chat-button.active").length == 0) {
                        //        window.clearInterval(animationInterval);
                        //    }
                        //}, 100);
                    });

                });
                $(".chat-button-icon img").each(function(){
                    $(this).closest(".chat-button-link").addClass("has-image");
                });

                $("head").append("<style id=''>"+customCSS+"</style>");

            }
        }

    });


    $(window).resize(function(){
        setStickyWidgetMenu();
    });

    function checkForOnHoverText(button) {
        var buttonPosition = getButtonPosition(button);
        if ($("#gsb-buttons-"+button.id).hasClass("single")) {
            var channel_title = $("#gsb-buttons-"+button.id+" .gsb-trigger .chat-button a").attr("data-scb");
            $("#gsb-buttons-"+button.id+" .gsb-trigger .chat-button a").removeAttr("data-tooltip-dir data-scb");
            $("#gsb-buttons-"+button.id+" .gsb-trigger .chat-button a").removeClass("scb-tooltip cooltipz--visible");
            $(".gsb-trigger .chat-button ").addClass("scb-tooltip cooltipz--visible");
            $("#gsb-buttons-"+button.id+" .gsb-trigger .chat-button.scb-tooltip").attr("data-tooltip-dir", (buttonPosition=="right")?"left":"right");
            $("#gsb-buttons-"+button.id+" .gsb-trigger .chat-button").attr("data-scb",channel_title);
        }
    }

    function checkForPendingMessage(button) {
        console.log(button);
        var isTriggered = getCookie("gsb-button-click-"+button.id);
        if(($("#gsb-buttons-"+button.id+" .gsb-button-list .chat-button").length == 0) || button.settings.has_pending_message == "yes"){
            if(!(isTriggered)) {
                if(button.settings.has_pending_message == "yes") {
                    if ($("#gsb-buttons-"+button.id).hasClass("single")) {
                        $("#gsb-buttons-"+button.id+" .gsb-trigger .chat-button a").append("<span class='gsb-pending-message'>" + button.settings.no_of_messages + "</span>");
                        $("#gsb-buttons-"+button.id+" .gsb-trigger .chat-button a").after("<span class='gsb-pending-message'>" + button.settings.no_of_messages + "</span>");
                    } else {
                        $("#gsb-buttons-"+button.id+" .gsb-trigger .gsb-trigger-top a").append("<span class='gsb-pending-message'>" + button.settings.no_of_messages + "</span>");
                        $("#gsb-buttons-"+button.id+" .gsb-trigger .gsb-trigger-top a").after("<span class='gsb-pending-message'>" + button.settings.no_of_messages + "</span>");
                    }

                    tempString = 0;
                    $("#gsb-buttons-"+button.id+" .gsb-pending-message").width("auto").height("auto");
                    $("#gsb-buttons-"+button.id+" .gsb-pending-message").each(function () {
                        if (tempString < $(this).width()) {
                            tempString = $(this).width();
                        }
                        if (tempString < $(this).height()) {
                            tempString = $(this).height();
                        }
                    });

                    $("#gsb-buttons-"+button.id+" .gsb-pending-message").width(tempString).height(tempString);
                    $("#gsb-buttons-"+button.id+" .gsb-pending-message").css("color", button.settings.message_text_color);
                    $("#gsb-buttons-"+button.id+" .gsb-pending-message").css("background-color", button.settings.message_bg_color);
                }
            }
        }
    }

    function checkForAnimation(button) {
        var isTriggered = getCookie("gsb-button-click-"+button.id);
        if(!(isTriggered) ){
            if ($("#gsb-buttons-"+button.id).hasClass("single")) {
                $("#gsb-buttons-"+button.id+" .gsb-trigger .chat-button a").addClass(button.settings.animation);
            } else {
                $("#gsb-buttons-"+button.id+" .gsb-trigger .gsb-trigger-top a").addClass(button.settings.animation);
            }
        }
    }

    function checkForTimeDelay(button) {
        if (button.triggers.after_seconds == "yes") {
            var isTriggered = getCookie("gsb-button-view-"+button.id);
            if(!(isTriggered)) {
                $("#gsb-buttons-" + button.id).hide();
                var pageTimer = parseInt(button.triggers.seconds);
                if (pageTimer > 0) {
                    setTimeout(function () {
                        $("#gsb-buttons-" + button.id).show();
                        setCookie("gsb-button-view-" + button.id, true, 2);
                    }, pageTimer * 1000);
                }
            }
        }
    }

    function checkForPageScroll(button) {
        if (button.triggers.on_scroll == "yes") {
            var isTriggered = getCookie("gsb-button-view-"+button.id);
            if(!(isTriggered)) {
                $("#gsb-buttons-" + button.id).hide();
                var pageScroll = parseInt(button.triggers.page_scroll);
                jQuery(window).scroll(function () {
                    pageScroll = parseInt(button.triggers.page_scroll);
                    var scrollHeight = jQuery(document).height() - jQuery(window).height();
                    var scrollPos = jQuery(window).scrollTop();
                    if (scrollPos != 0) {
                        if (((scrollPos / scrollHeight) * 100) >= pageScroll) {
                            $("#gsb-buttons-" + button.id).show();
                            setCookie("gsb-button-view-" + button.id, true, 2);
                        }
                    }
                });
            }
        }
    }

    function checkForExitIntent(button) {
        /* Exit intent functionality */
        if (button.triggers.exit_intent == "yes") {
            if (button.triggers.browser == "yes") {
                var isTriggered = getCookie("gsb-button-view-"+button.id);
                if(!(isTriggered)) {
                    $("#gsb-buttons-" + button.id + "").hide();
                    var position = getButtonPosition(button);
                    exitIntentEvent(document, 'mouseout', function (evt) {
                        if (evt.toElement == null && evt.relatedTarget == null) {
                            if (!widgetStatus) {
                                $("#gsb-buttons-" + button.id + "").show();
                                $("#gsb-buttons-" + button.id + "").append("<div class='exit-intent'></div>");
                                if (position == "left") {
                                    $("#gsb-buttons-" + button.id + " .exit-intent").addClass("left-position");
                                } else {
                                    $("#gsb-buttons-" + button.id + " .exit-intent").addClass("right-position");
                                }
                                if (!$("#gsb-buttons-" + button.id + "").hasClass("single-btn")) {
                                    $("#gsb-buttons-" + button.id + " .main-button").trigger("click");
                                }
                                setTimeout(function () {
                                    $("#gsb-buttons-" + button.id + " .exit-intent").addClass("active");
                                    setTimeout(function () {
                                        $("#gsb-buttons-" + button.id + " .exit-intent").removeClass("active");
                                    }, 2000);
                                }, 100);
                                widgetStatus = true;
                                setCookie("gsb-button-view-" + button.id, true, 2);
                            }
                        }
                    });
                }
            }
            if (button.triggers.on_inactivity == "yes") {
                idleInterval = setInterval(function() {idleTimerFN(button);}, 1000);
                $(document).on("mousemove", function (e) {
                    idleTimer = 0;
                });
                $(document).on("keyup", function (e) {
                    idleTimer = 0;
                });
            }
        }
    }

    function idleTimerFN(button) {
        idleTimer = idleTimer + 1;
        //console.log(idleTimer)
        var isTriggered = getCookie("gsb-button-view-"+button.id);
        if(!(isTriggered)) {
            $("#gsb-buttons-" + button.id + "").hide();
            if (idleTimer > 59) {
                if (!widgetStatus) {
                    var position = getButtonPosition(button);
                    $("#gsb-buttons-" + button.id + "").show();
                    $("#gsb-buttons-" + button.id + "").append("<div class='exit-intent'></div>");
                    if (position == "left") {
                        $("#gsb-buttons-" + button.id + " .exit-intent").addClass("left-position");
                    } else {
                        $("#gsb-buttons-" + button.id + " .exit-intent").addClass("right-position");
                    }
                    if (!$("#gsb-buttons-" + button.id + "").hasClass("single-btn")) {
                        $("#gsb-buttons-" + button.id + " .main-button").trigger("click");
                    }
                    setTimeout(function () {
                        $("#gsb-buttons-" + button.id + " .exit-intent").addClass("active");
                        setTimeout(function () {
                            $("#gsb-buttons-" + button.id + " .exit-intent").removeClass("active");
                        }, 2000);
                    }, 100);
                    widgetStatus = true;
                    setCookie("gsb-button-view-" + button.id, true, 2);
                }
                window.clearInterval(idleInterval);
            }
        }
    }

    function getButtonPosition(button) {
        if(button.settings.position == "custom") {
            return button.settings.custom_position;
        }
        return button.settings.position;
    }

    function getTooltipPosition(button) {
        if(button.settings.menu_view == "vertical") {
            var buttonPos = getButtonPosition(button);
            if(buttonPos == "right") {
                return "left";
            } else {
                return "right";
            }
        }
        return "top";
    }

    function getChannelSetting(channel, buttonId) {
        var channelURL = getChannelURL(channel, buttonId);
        return channelURL;
    }

    function getChannelURL(channel, buttonId) {
        if(channel.channel == "whatsapp" && !isDesktop) {
            channel.href = "https://wa.me/"+channel.value;
            channel.target = "";
        }
        var channelIcon = getChannelIcon(channel, buttonId);
        var channelClass = "channel-"+channel.channel+" chat-button-link button-link-"+channel.channel+"-"+buttonId;
        var channelId = "chat-button-"+channel.channel+"-"+buttonId;
        if(channel.custom_class != "") {
            channelClass += " "+$.trim(channel.custom_class);
        }
        if(channel.custom_id != "") {
            channelId = $.trim(channel.custom_id);
        }
        if((channel.channel != 'instagram')  || (channel.channel == "instagram" && channel.bg_color != "#df0079")) {
            customCSS += "#gsb-buttons-" + buttonId + " .channel-" + channel.channel + " {background: " + channel.bg_color + "; color: " + channel.text_color + "; }";
            customCSS += "#gsb-buttons-" + buttonId + " .channel-" + channel.channel + " svg {fill: " + channel.text_color + "; color: " + channel.text_color + "; }";
            customCSS += "#gsb-buttons-" + buttonId + " .channel-" + channel.channel + ":hover {background: " + channel.bg_hover_color + "; color: " + channel.text_hover_color + "; }";
            customCSS += "#gsb-buttons-" + buttonId + " .channel-" + channel.channel + ":hover svg {fill: " + channel.text_hover_color + "; color: " + channel.text_hover_color + "; }";
        }

        if(channel.channel == "slack" && channel.text_color != "#ffffff") {
            customCSS += "#gsb-buttons-" + buttonId + " .channel-" + channel.channel + ":not(:hover) svg path {fill: " + channel.text_color + "; }";
        }
        if(channel.channel == "slack" && channel.text_hover_color != "#ffffff") {
            customCSS += "#gsb-buttons-" + buttonId + " .channel-" + channel.channel + ":hover svg path {fill: " + channel.text_hover_color + "; color: " + channel.text_hover_color + "; }";
        }
        return "<div class='chat-button'><a href='"+channel.href+"' data-scb='"+channel.title+"' target='"+channel.target+"' class='scb-tooltip "+channelClass+" gsb-social-channel' id='"+channelId+"' data-channel='"+channel.channel+"'><span class='sr-only'>"+channel.title+"</span>"+channelIcon+"</a></div>";
    }

    function getChannelIcon(channel, buttonId) {
        var channelIcon = "<span class='chat-button-icon chat-button-"+channel.channel+"-"+buttonId+"'>";
        if(channel.image_url != "") {
            channelIcon += "<img src='"+channel.image_url+"' alt='"+channel.title+"' />";
        } else {
            channelIcon += channel.icon;
        }
        channelIcon += "</span>";
        return channelIcon;
    }

    function getActiveButtons(button){
        var activeButtons = 0;
        if(button.channels.length) {
            $.each(button.channels, function (key, channel){
                if(isChannelActive(channel)) {
                    activeButtons++;
                }
            });
        }
        return activeButtons;
    }

    function isChannelActive(channel) {
        if(channel.value != "" && ((isDesktop && channel.for_desktop == 'yes') || (!isDesktop && channel.for_mobile == 'yes'))) {
            return true;
        }
        return false;
    }

    /* set menu height for small windows */
    function setStickyWidgetMenu() {
        if($(".ginger-front-buttons").length && $(".sticky-button-list").length && $(".sticky-button-list .channel-btn").length && $(".ginger-front-buttons .cta-button").length) {
            $(".sticky-button-list .button-list").attr("style","");
            $(".sticky-button-list .button-list").removeClass("has-grid-layout");
            /* check for current position */
            var currentPos = parseInt(gsb_settings.icon_size)+parseInt(gsb_settings.bottom);
            if($(".sticky-button-list .button-list .channel-btn").length > 2) {
                console.log(parseInt($(".sticky-button-list .button-list .channel-btn").length)*(parseInt(gsb_settings.icon_size)+5));
                currentPos += parseInt($(".sticky-button-list .button-list .channel-btn").length)*(parseInt(gsb_settings.icon_size)+5);
                if(currentPos >= $(window).height()) {
                    /* set height of menu */
                    var contentWidth = Math.floor(Math.sqrt(parseInt($(".sticky-button-list .button-list .channel-btn").length)));
                    contentWidth = (parseInt(gsb_settings.icon_size)+5)*contentWidth;
                    $(".sticky-button-list .button-list").height(contentWidth);

                    /* set width of menu */
                    contentWidth = Math.ceil(Math.sqrt(parseInt($(".sticky-button-list .button-list .channel-btn").length)));
                    contentWidth = (parseInt(gsb_settings.icon_size)+5)*contentWidth;
                    $(".sticky-button-list .button-list").width(contentWidth);

                    $(".sticky-button-list .button-list").addClass("has-grid-layout");
                    $(".sticky-button-list .button-list").css("bottom", (parseInt(gsb_settings.icon_size)+5)+"px");
                    $(".sticky-button-list .button-list .ginger-social-channel").attr("data-ginger-tooltip-location", "top");
                } else {

                }
            }
        }
    }

    function exitIntentEvent(obj, evt, fn) {
        if (obj.addEventListener) {
            obj.addEventListener(evt, fn, false);
        }
        else if (obj.attachEvent) {
            obj.attachEvent("on" + evt, fn);
        }
    }

    /* Global Cookie Functions for Read, Write and Remove  */
    function getCookie(name) {
        var v = document.cookie.match('(^|;) ?' + name + '=([^;]*)(;|$)');
        return v ? v[2] : null;
    }

    function setCookie(name, value, hours) {
        var d = new Date;
        d.setTime(d.getTime() + 60*60*1000*hours);
        document.cookie = name + "=" + value + ";path=/;expires=" + d.toGMTString();
    }

    function deleteCookie(name) {
        setCookie(name, '', -1);
    }
})(jQuery);